﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.Diagnostics;
using System.Drawing;
using System.Threading;
using System.Windows.Media;
using System.IO;

using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Helpers;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.Plugins;
using Styx.Pathing;

namespace PeerPickpocket
{
    public class PeerPickpocket : HBPlugin
    {
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
		
        public override string Name { get { return "PeerPickpocket"; } }
        public override string Author { get { return "ikbeneenpeer"; } }
        public override Version Version { get { return new Version(1, 0, 0); } }
        public override string ButtonText { get { return "Settings"; } }
        public override bool WantButton { get { return true; } }

        #region PeerPickpocket Pulse
        public override void Pulse()
        {	
			while (!Me.Mounted && Me.IsMoving && !Me.HasAura("Burst of Speed"))
			{
				CastSpell("Burst of Speed");
				StyxWoW.SleepForLagDuration();
			}
				
			if (!Me.Mounted && !Me.Combat && !Me.IsCasting && !Me.HasAura("Stealth"))
            {
				CastSpell("Stealth");		
            }

            while (Me.Combat)
            {
                if (SpellManager.HasSpell("Preparation") && !SpellManager.CanCast("Vanish") && SpellManager.CanCast("Preparation") && !Me.HasAura("Vanish"))
                {
                    CastSpell("Preparation");
                }
                if (SpellManager.HasSpell("Vanish") && SpellManager.CanCast("Vanish") && !Me.HasAura("Stealth"))
                {
                    CastSpell("Vanish");
                }
            }

		
			if (Me.CurrentTarget.HasAura("Sap"))
			{
                Blacklist.Add(StyxWoW.Me.CurrentTarget, BlacklistFlags.Combat, TimeSpan.FromSeconds(10));
            }
				
			if (Me.HasAura("Vanish"))
			{
                Blacklist.Add(StyxWoW.Me.CurrentTarget, BlacklistFlags.Combat, TimeSpan.FromSeconds(10));
				StyxWoW.Me.ClearTarget();
            }
		}
        #endregion

        #region PeerPickpocket Behaviors
        public void CastSpell(string SpellName)
        {
            if (SpellManager.CanCast(SpellName))
            {
                CastSpell(SpellName);
            }

        }
        #endregion

    }

}
